package rozdzial18.monikairobert;


import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

public class MonikaIRobertKontoSynchroZakupyTest {
  public static void main(String[] args) throws InterruptedException {
    for (int i = 0; i < 10; i++) {
      KontoBankoweSynchroZakupy konto = new KontoBankoweSynchroZakupy();
      MonikaIRobertKontoSynchroZakupy robert = new MonikaIRobertKontoSynchroZakupy("Robert", konto, 50);
      MonikaIRobertKontoSynchroZakupy monika = new MonikaIRobertKontoSynchroZakupy("Monika", konto, 100);
      ExecutorService wykonawca = Executors.newFixedThreadPool(2);
      wykonawca.execute(robert);
      wykonawca.execute(monika);
      wykonawca.shutdown();
      //wykonawca.awaitTermination(1, TimeUnit.MINUTES);
      //System.out.println("---");
    }
  }
}

class MonikaIRobertKontoSynchroZakupy implements Runnable {
  private final String imie;
  private final KontoBankoweSynchroZakupy konto;
  private final int kwotaDoWydania;

  MonikaIRobertKontoSynchroZakupy(String imie, KontoBankoweSynchroZakupy konto, int kwotaDoWydania) {
    this.imie = imie;
    this.konto = konto;
    this.kwotaDoWydania = kwotaDoWydania;
  }

  public void run() {
    zrobZakupy(kwotaDoWydania);
  }

  private synchronized void zrobZakupy(int kwota) {
    if (konto.getStan() >= kwota) {
      System.out.println(imie + " zamierza wydać trochę pieniędzy.");
      konto.wydaj(kwota);
      System.out.println(imie + " kończy zakupy.");
    } else {
      System.out.println("Przykro mi, nie masz tylu pieniędzy " + imie + ".");
    }
  }
    
}

class KontoBankoweSynchroZakupy {
  private int stan = 100;
  
  public int getStan() {
    return stan;
  }
  
  public void wydaj(int kwota) {
    stan = stan - kwota;
    if (stan < 0) {
      System.out.println("Przekroczenie limitu!");
    }
  }
}
